#!/usr/bin/env python
# -*- coding: utf-8 -*-
# @Time    : 17-7-8
# @Author  : JCai
# @desc    :

import os
import django
os.environ['DJANGO_SETTINGS_MODULE'] = 'EBayClub.settings'
django.setup()
import urllib
import urllib2

from django.utils import timezone

from info_sync.models.listing_info_models import EbayListing, EbayListingVariations, EBayListingInfoMore

server_host = 'http://122.5.32.82:8093/ebay/notify/sync/'
timeout = 90

def listing_notify(notify_info):
    try:
        return eval(urllib2.urlopen(server_host, urllib.urlencode(notify_info), timeout=timeout).read())
    except Exception as e:
        print 'Unkown error:', str(e)
        if str(e).find('timed out') != '-1':
            print 'Unkown error: request again'
            try:
                return eval(urllib2.urlopen(server_host, urllib.urlencode(notify_info), timeout=2*timeout).read())
            except Exception as e:
                return {'result': False, 'message': str(e)}
        else:
            return {'result': False, 'message': str(e)}
    pass


def base_info_update(item_id, edit_data):
    base_info = edit_data.get('base', '')
    if len(base_info):
        if type(base_info) != type({}):
            try:
                base_info = eval(base_info)
            except Exception as e:
                base_info = {}
    if len(base_info):
        if item_id:
            base_listings = EbayListing.objects.filter(ItemID=item_id)
            if base_listings:
                base_listing = base_listings.first()
                if base_listing:
                    base_listings.update(**base_info)
            else:
                EbayListing.objects.create(
                    ItemID=item_id,
                    **base_info
                )


def variation_update(item_id, edit_data):
    variation_list = edit_data.get('variation', '')
    if len(variation_list):
        if type(variation_list) != type([]):
            try:
                variation_list = eval(variation_list)
            except:
                variation_list = []

    EbayListingVariations.objects.filter(ItemID=item_id).update(refresh=-1)
    if len(variation_list):
        for each in variation_list:
            seller_sku = each.get('seller_sku', '')
            variation_listings = EbayListingVariations.objects.filter(ItemID=item_id, seller_sku=seller_sku)
            if variation_listings:
                variation_listing = variation_listings.first()
                if variation_listing:
                    each.pop('seller_sku')
                    variation_listings.update(**each)
            else:
                EbayListingVariations.objects.create(
                    ItemID=item_id,
                    **each
                )


def more_info_update(item_id, edit_data):
    more_info = edit_data.get('more', '')
    if len(more_info):
        if type(more_info) != type({}):
            try:
                more_info = eval(more_info)
            except:
                more_info = {}
    if len(more_info):
        more_listings = EBayListingInfoMore.objects.filter(ItemID=item_id)
        if more_listings:
            more_listing = more_listings.first()
            if more_listing:
                more_listings.update(write_date=timezone.now(), **more_info)
        else:
            EBayListingInfoMore.objects.create(
                ItemID=item_id,
                **more_info
            )


def listing_notify_update(notify_info):
    result = listing_notify(notify_info)
    if len(result) < 1:
        item_id = notify_info.get('ItemID', '')
        if len(item_id):
            print 'ItemID:\t%s' % item_id
            base_info_update(item_id, notify_info)
            variation_update(item_id, notify_info)
            more_info_update(item_id, notify_info)


def listing_notify_list(notify_list):
    result = listing_notify(notify_list)
    if len(result) < 1:
        edit_list_info = notify_list.get('list', [])
        edit_list = []
        try:
            if type(edit_list_info) != type([]):
                edit_list = eval(edit_list_info)
            else:
                edit_list = edit_list_info
        except:
            pass
        for item_info in edit_list:
            item = {}
            try:
                if type(item_info) != type({}):
                    item = eval(item_info)
                else:
                    item = item_info
            except:
                pass

            item_id = item.get('ItemID', '')
            if len(item_id):
                print 'ItemID:\t%s' % item_id
                try:
                    base_info_update(item_id, item)
                    variation_update(item_id, item)
                    more_info_update(item_id, item)
                except Exception as e:
                    print 'ItemID:\t%s\n\t%s' % (item_id, str(e))


if __name__ == '__main__':
    listing_notify_update({'ItemID': '1111', 'base': {'ListingStatus': 'Completed', 'write_date': '2017-07-21T11:03:45Z', 'end_date': '2017-07-19T02:44:22.000Z'}})
